Index: imaps-frontend/src/components/PublishForm/PublishForm.jsx
===================================================================
--- imaps-frontend/src/components/PublishForm/PublishForm.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/PublishForm/PublishForm.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,157 @@
+import React, { useState } from 'react';
+import styles from './PublishForm.module.css';
+
+const PublishForm = ({ isAdmin = false, formData, onSubmit, onCancel, onApprove, onDeny }) => {
+    const [state, setState] = useState(isAdmin ? 'viewing' : 'writing');
+    const [form, setForm] = useState(
+        formData || {
+            id: -1,
+            name: '',
+            lastName: '',
+            mapName: '',
+            mapType: 'Other',
+            googleMapsUrl: '',
+        }
+    );
+    const [errors, setErrors] = useState({});
+
+    const mapTypeOptions = ['Hospital', 'Faculty', 'House', 'Other'];
+
+    const handleChange = (e) => {
+        const { name, value } = e.target;
+        setForm((prev) => ({ ...prev, [name]: value }));
+        setErrors((prev) => ({ ...prev, [name]: '' }));
+    };
+
+    const validateForm = () => {
+        const newErrors = {};
+        if (!form.name.trim()) newErrors.name = 'Name is required.';
+        if (!form.lastName.trim()) newErrors.lastName = 'Last Name is required.';
+        if (!form.googleMapsUrl.trim()) newErrors.googleMapsUrl = 'Google Maps URL is required.';
+        return newErrors;
+    };
+
+    const handleSubmit = () => {
+        const formErrors = validateForm();
+        if (Object.keys(formErrors).length > 0) {
+            setErrors(formErrors);
+            return;
+        }
+
+        if (state === 'writing') {
+            onSubmit(form);
+        }
+    };
+
+    return (
+        <>
+            <div className={styles.modalOverlay}></div>
+            <div className={styles.modal}>
+                <div className={styles.modalContent}>
+                    <h2>{state === 'writing' ? 'Publish Map' : 'View Map Details'}</h2>
+                    {state === 'writing' ? (
+                        <form>
+                            <div>
+                                <label>Name:</label>
+                                <input
+                                    type="text"
+                                    name="name"
+                                    value={form.name}
+                                    onChange={handleChange}
+                                />
+                                {errors.name && <p className={styles.error}>{errors.name}</p>}
+                            </div>
+                            <div>
+                                <label>Last Name:</label>
+                                <input
+                                    type="text"
+                                    name="lastName"
+                                    value={form.lastName}
+                                    onChange={handleChange}
+                                />
+                                {errors.lastName && <p className={styles.error}>{errors.lastName}</p>}
+                            </div>
+                            <div>
+                                <label>Google Maps URL:</label>
+                                <input
+                                    type="url"
+                                    name="googleMapsUrl"
+                                    value={form.googleMapsUrl}
+                                    onChange={handleChange}
+                                />
+                                {errors.googleMapsUrl && (
+                                    <p className={styles.error}>{errors.googleMapsUrl}</p>
+                                )}
+                            </div>
+                            <div>
+                                <label>Type of Map:</label>
+                                <select
+                                    name="mapType"
+                                    value={form.mapType}
+                                    onChange={handleChange}
+                                >
+                                    {mapTypeOptions.map((option) => (
+                                        <option key={option} value={option}>
+                                            {option}
+                                        </option>
+                                    ))}
+                                </select>
+                            </div>
+                            <div className={styles.buttonGroup}>
+                                <button type="button" onClick={handleSubmit}>
+                                    Submit
+                                </button>
+                                <button
+                                    type="button"
+                                    className={styles.cancelButton}
+                                    onClick={onCancel}
+                                >
+                                    Cancel
+                                </button>
+                            </div>
+                        </form>
+                    ) : (
+                        <div>
+                            <p><strong>Map Name:</strong> {form.mapName}</p>
+                            <p><strong>Name:</strong> {form.name}</p>
+                            <p><strong>Last Name:</strong> {form.lastName}</p>
+                            <p>
+                                <strong>Google Maps URL:</strong>{' '}
+                                <a
+                                    href={form.googleMapsUrl}
+                                    target="_blank"
+                                    rel="noopener noreferrer"
+                                >
+                                    {form.googleMapsUrl}
+                                </a>
+                            </p>
+                            <p><strong>Type of Map:</strong> {form.mapType}</p>
+                            <div className={styles.buttonGroup}>
+                                <button
+                                    className={styles.cancelButton}
+                                    onClick={onCancel}
+                                >
+                                    Cancel
+                                </button>
+                                <button
+                                    className={styles.approveButton}
+                                    onClick={() => onApprove(form.id,form.mapName)}
+                                >
+                                    Approve
+                                </button>
+                                <button
+                                    className={styles.denyButton}
+                                    onClick={() => onDeny(form.id,form.mapName,"Reason")}
+                                >
+                                    Deny
+                                </button>
+                            </div>
+                        </div>
+                    )}
+                </div>
+            </div>
+        </>
+    );
+};
+
+export default PublishForm;
Index: imaps-frontend/src/components/SaveMap/SaveMap.jsx
===================================================================
--- imaps-frontend/src/components/SaveMap/SaveMap.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/SaveMap/SaveMap.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -2,4 +2,5 @@
 import HttpService from '../../scripts/net/HttpService';
 import styles from './SaveMap.module.css';
+import triggerMapSave from "../../scripts/util/triggerMapSave.js";
 
 const SaveMap = ({submitHandler}) => {
@@ -8,5 +9,8 @@
     const handleSubmit = (event) => {
         event.preventDefault();
-        submitHandler(name);
+        // submitHandler();
+        // const mapSaveEvent = new CustomEvent("mapsave",{});
+        // window.dispatchEvent(mapSaveEvent)
+        triggerMapSave();
     };
 
@@ -15,16 +19,4 @@
         <div className={styles.saveMapContainer}>
             <form onSubmit={handleSubmit} className={styles.saveMapForm}>
-                <div>
-                    <label htmlFor="name">Map Name: </label>
-                    <input 
-                        type="text" 
-                        id="name" 
-                        value={name} 
-                        onChange={(e) => setName(e.target.value)} 
-                        placeholder="Enter map name" 
-                        required
-                        className={styles.saveMapInput}
-                    />
-                </div>
                 <div>
                     <button type="submit" className={styles.saveMapButton}>Save Map</button>
Index: imaps-frontend/src/components/SearchBar/SearchBar.jsx
===================================================================
--- imaps-frontend/src/components/SearchBar/SearchBar.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/SearchBar/SearchBar.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,3 +1,4 @@
-import React, { useState } from "react";
+import React, { useState, useEffect, useRef } from "react";
+import ReactDOM from "react-dom";
 import searchIcon from "../../assets/search_icon.png";
 import routeIcon from "../../assets/route_icon.png";
@@ -5,8 +6,13 @@
 import styles from "./SearchBar.module.css";
 
-function SearchBar(props) {
+function SearchBar({ map, handleDirectionsSubmit, setIsPanelOpen, setSelectedRoom, availableShapes,handleFloorChange }) {
   const [isExpanded, setIsExpanded] = useState(false);
   const [from, setFrom] = useState("");
   const [to, setTo] = useState("");
+  const [availableOptions, setAvailableOptions] = useState([]);
+  const [filteredOptions, setFilteredOptions] = useState([]);
+  const [dropdownVisible, setDropdownVisible] = useState(false);
+  const [inputFieldType, setInputFieldType] = useState("");
+  const dropdownRef = useRef(null);
 
   const toggleExpanded = () => {
@@ -14,84 +20,143 @@
   };
 
-  function searchRoom(){
-    props.map.search();
+  function searchRoom() {
+    let foundRoom = availableShapes.find(sh => sh.info.name === from)
+    console.log("map fnum",map.floorNum)
+    if(foundRoom.floorNum !== map.floorNum){
+      handleFloorChange(foundRoom.floorNum);
+    }
 
+
+    console.log("FOUND ROOM: " + foundRoom)
+    map.highlightShape(from);
+    setSelectedRoom(foundRoom);
+    setIsPanelOpen(true);
   }
 
-  const handleDirectionsSubmit = () => {
-    console.log(`From: ${from}, To: ${to}`);
-    const url = new URL('http://localhost:8080/api/public/navigate');
-    url.searchParams.append('from', from);
-    url.searchParams.append('to', to);
+  const handleInputFocus = (field) => {
+    if (availableOptions.length === 0 && map) {
+      setAvailableOptions(
+          availableShapes
+              .filter((sh) => sh.className === "RenderedRoom")
+              .map((shape) => shape.info.name)
+      );
+    }
+    setDropdownVisible(true);
+    setInputFieldType(field);
+  };
 
-    fetch(url)
-            .then(response => {
-                if (!response.ok) {
-                    throw new Error('Network response was not ok');
-                }
-                return response.json();
-            })
-            .then(data => {
-                console.log('Success:', data);
-                const points = data.map(item => item.coordinates);
-                props.map.drawRoute(points);
-            })
-            .catch(error => {
-                console.error('Error:', error);
-            });
+  const handleInputChange = (setter) => (event) => {
+    const value = event.target.value;
+    setter(value);
+    setDropdownVisible(true);
+
+    const filtered = availableOptions.filter((option) =>
+        option.toLowerCase().includes(value.toLowerCase())
+    );
+    setFilteredOptions(filtered);
+  };
+
+  const handleOptionClick = (option) => {
+    if (inputFieldType === "from") {
+      setFrom(option);
+    } else if (inputFieldType === "to") {
+      setTo(option);
+    }
+    setDropdownVisible(false);
+  };
+
+  const renderDropdown = () => {
+    if (!dropdownVisible || filteredOptions.length === 0) return null;
+
+    const position = dropdownRef.current?.getBoundingClientRect() || { top: 0, left: 0, width: 0 };
+
+    return ReactDOM.createPortal(
+        <ul
+            className={styles.dropdown}
+            style={{
+              position: "absolute",
+              top: position.top + position.height,
+              left: position.left,
+              width: position.width,
+            }}
+        >
+          {filteredOptions.map((option, index) => (
+              <li
+                  key={index}
+                  className={styles.dropdownItem}
+                  onClick={() => handleOptionClick(option)}
+              >
+                {option}
+              </li>
+          ))}
+        </ul>,
+        document.body // Portal renders outside the parent hierarchy
+    );
   };
 
   return (
-    <div className={styles.wrapper}>
-      {/* Regular search bar */}
-      {!isExpanded ? (
-        <div className={styles.searchBar}>
-          <input
-            type="search"
-            className={styles.inputField}
-            placeholder="Search location"
-            aria-label="Search"
-          />
-          <div className={styles.buttons}>
-            <button type="button" className={styles.iconButton} onClick={searchRoom}>
-              <img src={searchIcon} alt="Search Icon" />
-            </button>
-            <button type="button" className={styles.iconButton} onClick={toggleExpanded}>
-              <img src={routeIcon} alt="Route Icon" />
-            </button>
-          </div>
-        </div>
-      ) : (
-        /* Expanded view for directions */
-        <div className={styles.directionsContainer}>
-          <div className={styles.directionsInputs}>
-            <input
-              type="text"
-              placeholder="From"
-              aria-label="From"
-              value={from}
-              onChange={(e) => setFrom(e.target.value)}
-              className={styles.inputField}
-            />
-            <input
-              type="text"
-              placeholder="To"
-              aria-label="To"
-              value={to}
-              onChange={(e) => setTo(e.target.value)}
-              className={styles.inputField}
-            />
-          </div>
-          <div className={styles.buttons}>
-            <button type="button" className={styles.iconButton} onClick={handleDirectionsSubmit}>
-              <img src={searchIcon} alt="Submit Directions" />
-            </button>
-            <button type="button" className={styles.iconButton} onClick={toggleExpanded}>
-              <img src={closeIcon} alt="Close Icon" />
-            </button>
-          </div>
-        </div>
-      )}
-    </div>
+      <div className={styles.wrapper}>
+        {!isExpanded ? (
+            <div className={styles.searchBar}>
+              <input
+                  type="search"
+                  className={styles.inputField}
+                  placeholder="Search location"
+                  aria-label="Search"
+                  ref={dropdownRef} // Attach the input to calculate dropdown position
+                  onFocus={() => handleInputFocus("from")}
+                  onChange={handleInputChange(setFrom)}
+                  value={from}
+              />
+              {renderDropdown()}
+              <div className={styles.buttons}>
+                <button type="button" className={styles.iconButton} onClick={searchRoom}>
+                  <img src={searchIcon} alt="Search Icon" />
+                </button>
+                <button type="button" className={styles.iconButton} onClick={toggleExpanded}>
+                  <img src={routeIcon} alt="Route Icon" />
+                </button>
+              </div>
+            </div>
+        ) : (
+            <div className={styles.directionsContainer}>
+              <div className={styles.directionsInputs}>
+                <input
+                    type="text"
+                    placeholder="From"
+                    aria-label="From"
+                    value={from}
+                    onFocus={() => handleInputFocus("from")}
+                    onChange={handleInputChange(setFrom)}
+                    className={styles.inputField}
+                    ref={inputFieldType === "from" ? dropdownRef : null}
+                />
+                <input
+                    type="text"
+                    placeholder="To"
+                    aria-label="To"
+                    value={to}
+                    onFocus={() => handleInputFocus("to")}
+                    onChange={handleInputChange(setTo)}
+                    className={styles.inputField}
+                    ref={inputFieldType === "to" ? dropdownRef : null}
+                />
+                {renderDropdown()}
+              </div>
+              <div className={styles.buttons}>
+                <button
+                    type="button"
+                    className={styles.iconButton}
+                    onClick={() => handleDirectionsSubmit(from, to)}
+                >
+                  <img src={searchIcon} alt="Submit Directions" />
+                </button>
+                <button type="button" className={styles.iconButton} onClick={toggleExpanded}>
+                  <img src={closeIcon} alt="Close Icon" />
+                </button>
+              </div>
+            </div>
+        )}
+      </div>
   );
 }
Index: imaps-frontend/src/components/SideBar/SideBar.jsx
===================================================================
--- imaps-frontend/src/components/SideBar/SideBar.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/SideBar/SideBar.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -24,8 +24,8 @@
             </li>
             <li>
-              <Link to="/Maps">Maps</Link>
+              <Link to="/Maps">Browse Maps</Link>
             </li>
             <li>
-              <Link to="/Maps/FinkiMaps/Draw">Draw</Link>
+              <Link to="/myMaps">My Maps</Link>
             </li>
           </ul>
Index: imaps-frontend/src/components/Toast/Toast.jsx
===================================================================
--- imaps-frontend/src/components/Toast/Toast.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Toast/Toast.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,18 @@
+import React from "react";
+import PropTypes from "prop-types";
+import styles from "./Toast.module.css";
+
+const Toast = ({ message, type, onClose }) => {
+    return (
+        <div
+            className={`${styles.toast} ${type === 1 ? styles.success : styles.error}`}
+            onClick={onClose}
+        >
+            {message}
+        </div>
+    );
+};
+
+
+
+export default Toast;
